#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
#include <cctype>
#include <map>
#include <vector>
using namespace std;
#include "morfofun.hh"

static string pre, mid="=", aft=";", retval="";

static void Flush(const string &var2,
                  const string &vihre, const vector<string> &tab)
{
    /* token -> value */
    map<string, string> values;
    vector<string> tokens;
    map<string, pair<unsigned,unsigned> > valuecount;
    typedef vector<string>::const_iterator seti;
    for(unsigned a=0; a<tab.size(); ++a)
    {
        const string &s = tab[a];
        unsigned b = s.find('=');
        string value, token;
        if(b == s.npos)
        {
        	token = s;
        	value = s;
        }
        else
        {
            token = s.substr(0,b);
            value = s.substr(b+1);
        }
        values[token] = value;
        tokens.push_back(token);
        ++valuecount[value].first;
    }
    sort(tokens.begin(), tokens.end());
    unsigned prevdepth=1;
    
    multimap<unsigned, string> ehdot;
    
    for(seti i=tokens.begin(); i!=tokens.end(); ++i)
    {
        unsigned depth=prevdepth;
        if(i != tokens.begin())
        {
            seti j=i; --j;
            while(depth>0)
            {
                if(i->substr(0, depth-1) == j->substr(0, depth-1))break;
                --depth;
            }
        }
        seti j=i; ++j;
        if(j != tokens.end())
            for(; ; ++depth)
                if(i->substr(0, depth) != j->substr(0, depth))
                    break;
        if(depth > i->size())depth = i->size();
        ehdot.insert(pair<unsigned,string> (depth, *i));
        prevdepth = depth;
    }
    
    static unsigned problem=1;
    
    multimap<unsigned,string>::reverse_iterator i;
    prevdepth  = 0;
    bool brace = false;
    unsigned lab = 0;
    for(i=ehdot.rbegin(); i!=ehdot.rend(); ++i)
    {
    	const string &s = i->second;
    	unsigned depth = i->first;
    	
    	unsigned count = ehdot.count(depth);
    	
    	if(depth != prevdepth)
    	{
    	    if(brace)
    	        printf("goto hashskip%u_%u; }\nelse ", problem, depth);
    	    if(count > 1)
    	    {
    		    printf("if(%s.size() >= %u) {", var2.c_str(), depth);
    		    if(brace)putchar(' ');
    		}
    		if(brace)
    		    printf("hashskip%u_%u:", problem, depth);
    		if(count > 1)
    		{
    		    printf("\n  ");
    		    brace = true;
    		}
    		else
    		    brace = false;
    		prevdepth = depth;
         }
    	
        if(depth == s.size())
            printf("if(%s == \"%s\")", var2.c_str(), s.c_str());
        else
            printf("if(!strncmp(%s.c_str(), \"%s\", %s.size()))",
                var2.c_str(), s.c_str(), var2.c_str());
        const string &vs = values[s];
        if(valuecount[vs].first > 1)
        {
        	if(!valuecount[vs].second)
        	{
        		printf(" hashlab%u_%u: ", problem, ++lab);
        		valuecount[vs].second = lab;
        		goto MakeValue;
        	}
    		printf(" goto hashlab%u_%u;", problem, valuecount[vs].second);
        }
        else
        {
        MakeValue:
            printf("%s%s", pre.c_str(), mid.c_str());
            if(isalpha(vs[0]) && mid.size())
    	        for(unsigned a=0; a<vs.size(); ++a)
        	        putchar(toupper(vs[a]));
        	else
        		printf("%s", vs.c_str());
        	printf("%s", aft.c_str());
    	}
        printf("\n%selse ", brace ? "  " : "");
    }
	if(brace)printf("goto hashprob%u; }\nelse ", problem);
	
    printf("{ ");
    if(brace)printf("hashprob%u: ", problem);
    printf("fprintf(stderr, \"%s '%%s'\\n\", %s.c_str()); return %s; }\n",
           vihre.c_str(), var2.c_str(), retval.c_str());
    ++problem;
}

int main(void)
{
    char Buf[512];
    string var2, vihre;
    vector<string> tab;
    while(fgets(Buf,sizeof Buf,stdin))
    {
        string s = Buf;
        Trim(s);
        if(Buf[0]=='<' || Buf[0]=='|' || Buf[0]=='>' || Buf[0]==':' || Buf[0]=='^')
        {
        	if(tab.size()){Flush(var2,vihre,tab);tab.clear();}
            if(Buf[0]=='<')pre=s.substr(1);
            else if(Buf[0]=='|')mid=s.substr(1);
            else if(Buf[0]=='>')aft=s.substr(1);
            else if(Buf[0]=='^')retval=s.substr(1);
            else if(Buf[0]==':')
            {
                var2 = s.substr(1);
                unsigned b = var2.find(':');
                if(b != var2.npos)
                {
                    vihre = var2.substr(b+1);
                    var2.erase(b);
                }
            }
        }
        else if(s.size())tab.push_back(s);
    }
    if(tab.size())Flush(var2,vihre, tab);
    return 0;
}
